% Fact section. Do not modify, add or delete facts.

female(mary).
female(jane).
female(joan).
female(elizabeth).
female(sallyanne).
female(francis).

male(mark).
male(malcolm).
male(john).
male(bob).
male(sidney).

parent(mary, jane).
parent(mary, john).
parent(mary, joan).
parent(mark, jane).
parent(mark, john).
parent(malcolm, joan).
parent(jane, elizabeth).
parent(jane, bob).
parent(john, sidney).
parent(john, sallyanne).
parent(joan, francis).

% Predicate section. Please complete the following code.

mother(X, Y) :- parent(X, Y), female(X).
father(X, Y) :- parent(X, Y), male(X).
child(X, Y) :- parent(Y, X).
daughter(X, Y) :- child(X, Y), female(X).
son(X, Y) :- child(X, Y), male(X).

sister(X, Y) :- daughter(X, P), child(Y, P), (X \== Y).
brother(X, Y) :- son(X, P), child(Y, P), (X \== Y).
sibling(X, Y) :- child(X, P), parent(P, Y), (X \== Y).

uncle(X, Y) :- sibling(S, X), child(Y, S), male(X).
aunt(X, Y) :- sibling(S, X), child(Y, S), female(X).
cousin(X, Y) :- child(X, P1), sibling(P1, P2), child(Y, P2).

relative(X, Y) :- sibling(X, Y); cousin(X, Y); uncle(X, Y); uncle(Y, X); aunt(Y, X); aunt(X, Y); parent(X, Y); child(X, Y); parent(P, X), parent(Y, P); child(C, X), child(Y, C).

half_sister(X, Y) :- sister(X, Y), father(F1, X), father(F2, Y), mother(M1, X), mother(M2, Y), not(F1 = F2); not(M1 = M2).