% modulus predicate base cases
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
modulo(X, M, Y) :-
	X < M,
	Y is X.
modulo(X, X, Y) :-
	Y is 0.

% modulus predicate
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
modulo(X, M, Y) :-
	X > M,
	Bin is X - M,
	modulo(Bin, M, Y).


% division predicate base cases
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
divide_by(X, D, I, R) :-
	X < D,
	R is X,
	I is 0.
divide_by(X, X, I, R) :-
	R is 0,
	I is 1.

% division predicate
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
divide_by(X, D, I, R) :-
	X > D,
	Bin is X - D,
	divide_by(Bin, D, I1, R),
	I is I1 + 1.


% dwr predicate. checks if M is a factor of X by proving a remainder of 0
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dwr(X, M) :-
	0 is X mod M.

% factor predicate base case
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
factor(X, M, 1) :-
	M is 1.

% factor predicate
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
factor(X, M, C) :-
	C > 1,
	dwr(X, C),
	M is C;
	C > 1,
	C1 is C - 1,
	factor(X, M, C1).

% factor_of predicate
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
factor_of(X, M) :-
	C is X,
	factor(X, M1, C),
	M is M1.


% common factor predicate
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
common_factor(X, Y, M) :-
	factor_of(X, M),
	factor_of(Y, M).
	