% Calculating mean
% Total all the values using cMean
% Get list length
% Work out average
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
length([H|[]], 1).

length([H|T], L) :-
	length(T, Out),
	L is Out + 1.

cMean([H|[]], H).

cMean([H|T], X) :-
	cMean(T, Out),
	X is H + Out.

mean([H|T], X) :-
	cMean(T, Out),
	length([H|T], L),
	Total is Out + H,
	X is Total / L.


% Calculating variance
% Get the mean of all the values first
% Then get the square for the difference from the mean for every value using cVariance
% Add these up and devide by length
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cVariance([H|[]], M, X) :-
	Z is H - M,
	X is Z * Z.

cVariance([H|T], M, X) :-
	cVariance(T, M, Out),
	Z is H - M,
	S is Z * Z,
	X is S + Out.

variance([H|T], X) :-
	mean([H|T], M),
	length([H|T], L),
	Z is H - M,
	S is Z * Z,
	cVariance(T, M, Out),
	Total is S + Out,
	X is Total / L.


% Deleting the nth value
% Iterate until nth value is found
% Then send the tail back up, adding the previous heads to it on the way using append
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

append([], L, L).

append([H|T], L, [H|U]) :-
	append(T, L, U).

delete_nth(1, [H|T], T).

delete_nth(N, [H|T], L2) :-
	N > 1,
	N1 is N - 1,
	delete_nth(N1, T, L2A),
	append([H], L2A, L2).



% Post Order
% Find the first set of managed people, then move into second post order predicate
% (this will eliminate the first person in the tree, as per the question implies to do)
% Keep finding managed people until non are found
% Then combine the two people on the bottom of the tree into a list
% This is passed up the tree and appended to the combined people on the next level, etc.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

management_tree(adams, manages(brown, collins)).
management_tree(brown, manages(dorking, evans)).
management_tree(collins, manages(fortnum, gault)).
management_tree(dorking, manages(null, null)).
management_tree(evans, manages(null, null)).
management_tree(fortnum, manages(null, null)).
management_tree(gault, manages(null, null)).

post_order1(null, []).
	
post_order1(N, L) :-
	management_tree(N, manages(S1, S2)),
	post_order1(S1, L1),
	post_order1(S2, L2),
	append(L2, L1, L3),
	append(L3, [N], L).

post_order(N, L) :-
	management_tree(N, manages(S1, S2)),
	post_order1(S1, L1),
	post_order1(S2, L2),
	append(L2, L1, L).